t / test-lib.shon commit tests: stop worrying about obsolete environment variables (67e6d81)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano
   4#
   5# This program is free software: you can redistribute it and/or modify
   6# it under the terms of the GNU General Public License as published by
   7# the Free Software Foundation, either version 2 of the License, or
   8# (at your option) any later version.
   9#
  10# This program is distributed in the hope that it will be useful,
  11# but WITHOUT ANY WARRANTY; without even the implied warranty of
  12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  13# GNU General Public License for more details.
  14#
  15# You should have received a copy of the GNU General Public License
  16# along with this program.  If not, see http://www.gnu.org/licenses/ .
  17
  18# if --tee was passed, write the output not only to the terminal, but
  19# additionally to the file test-results/$BASENAME.out, too.
  20case "$GIT_TEST_TEE_STARTED, $* " in
  21done,*)
  22        # do not redirect again
  23        ;;
  24*' --tee '*|*' --va'*)
  25        mkdir -p test-results
  26        BASE=test-results/$(basename "$0" .sh)
  27        (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
  28         echo $? > $BASE.exit) | tee $BASE.out
  29        test "$(cat $BASE.exit)" = 0
  30        exit
  31        ;;
  32esac
  33
  34# Keep the original TERM for say_color
  35ORIGINAL_TERM=$TERM
  36
  37# For repeatability, reset the environment to known value.
  38LANG=C
  39LC_ALL=C
  40PAGER=cat
  41TZ=UTC
  42TERM=dumb
  43export LANG LC_ALL PAGER TERM TZ
  44EDITOR=:
  45unset VISUAL
  46unset GIT_EDITOR
  47unset EMAIL
  48unset GIT_ALTERNATE_OBJECT_DIRECTORIES
  49unset GIT_AUTHOR_DATE
  50GIT_AUTHOR_EMAIL=author@example.com
  51GIT_AUTHOR_NAME='A U Thor'
  52unset GIT_COMMITTER_DATE
  53GIT_COMMITTER_EMAIL=committer@example.com
  54GIT_COMMITTER_NAME='C O Mitter'
  55unset GIT_DIFF_OPTS
  56unset GIT_DIR
  57unset GIT_WORK_TREE
  58unset GIT_EXTERNAL_DIFF
  59unset GIT_INDEX_FILE
  60unset GIT_OBJECT_DIRECTORY
  61unset GIT_CEILING_DIRECTORIES
  62unset GIT_NOTES_REF
  63unset GIT_NOTES_DISPLAY_REF
  64unset GIT_NOTES_REWRITE_REF
  65unset GIT_NOTES_REWRITE_MODE
  66unset GIT_REFLOG_ACTION
  67unset GIT_CHERRY_PICK_HELP
  68unset GIT_QUIET
  69GIT_MERGE_VERBOSITY=5
  70export GIT_MERGE_VERBOSITY
  71export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
  72export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
  73export EDITOR
  74
  75# Protect ourselves from common misconfiguration to export
  76# CDPATH into the environment
  77unset CDPATH
  78
  79unset GREP_OPTIONS
  80
  81case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
  82        1|2|true)
  83                echo "* warning: Some tests will not work if GIT_TRACE" \
  84                        "is set as to trace on STDERR ! *"
  85                echo "* warning: Please set GIT_TRACE to something" \
  86                        "other than 1, 2 or true ! *"
  87                ;;
  88esac
  89
  90# Convenience
  91#
  92# A regexp to match 5 and 40 hexdigits
  93_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
  94_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
  95
  96# Each test should start with something like this, after copyright notices:
  97#
  98# test_description='Description of this test...
  99# This test checks if command xyzzy does the right thing...
 100# '
 101# . ./test-lib.sh
 102[ "x$ORIGINAL_TERM" != "xdumb" ] && (
 103                TERM=$ORIGINAL_TERM &&
 104                export TERM &&
 105                [ -t 1 ] &&
 106                tput bold >/dev/null 2>&1 &&
 107                tput setaf 1 >/dev/null 2>&1 &&
 108                tput sgr0 >/dev/null 2>&1
 109        ) &&
 110        color=t
 111
 112while test "$#" -ne 0
 113do
 114        case "$1" in
 115        -d|--d|--de|--deb|--debu|--debug)
 116                debug=t; shift ;;
 117        -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
 118                immediate=t; shift ;;
 119        -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
 120                GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
 121        -h|--h|--he|--hel|--help)
 122                help=t; shift ;;
 123        -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
 124                verbose=t; shift ;;
 125        -q|--q|--qu|--qui|--quie|--quiet)
 126                # Ignore --quiet under a TAP::Harness. Saying how many tests
 127                # passed without the ok/not ok details is always an error.
 128                test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
 129        --with-dashes)
 130                with_dashes=t; shift ;;
 131        --no-color)
 132                color=; shift ;;
 133        --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
 134                valgrind=t; verbose=t; shift ;;
 135        --tee)
 136                shift ;; # was handled already
 137        --root=*)
 138                root=$(expr "z$1" : 'z[^=]*=\(.*\)')
 139                shift ;;
 140        *)
 141                echo "error: unknown test option '$1'" >&2; exit 1 ;;
 142        esac
 143done
 144
 145if test -n "$color"; then
 146        say_color () {
 147                (
 148                TERM=$ORIGINAL_TERM
 149                export TERM
 150                case "$1" in
 151                        error) tput bold; tput setaf 1;; # bold red
 152                        skip)  tput bold; tput setaf 2;; # bold green
 153                        pass)  tput setaf 2;;            # green
 154                        info)  tput setaf 3;;            # brown
 155                        *) test -n "$quiet" && return;;
 156                esac
 157                shift
 158                printf "%s" "$*"
 159                tput sgr0
 160                echo
 161                )
 162        }
 163else
 164        say_color() {
 165                test -z "$1" && test -n "$quiet" && return
 166                shift
 167                echo "$*"
 168        }
 169fi
 170
 171error () {
 172        say_color error "error: $*"
 173        GIT_EXIT_OK=t
 174        exit 1
 175}
 176
 177say () {
 178        say_color info "$*"
 179}
 180
 181test "${test_description}" != "" ||
 182error "Test script did not set test_description."
 183
 184if test "$help" = "t"
 185then
 186        echo "$test_description"
 187        exit 0
 188fi
 189
 190exec 5>&1
 191if test "$verbose" = "t"
 192then
 193        exec 4>&2 3>&1
 194else
 195        exec 4>/dev/null 3>/dev/null
 196fi
 197
 198test_failure=0
 199test_count=0
 200test_fixed=0
 201test_broken=0
 202test_success=0
 203
 204test_external_has_tap=0
 205
 206die () {
 207        code=$?
 208        if test -n "$GIT_EXIT_OK"
 209        then
 210                exit $code
 211        else
 212                echo >&5 "FATAL: Unexpected exit with code $code"
 213                exit 1
 214        fi
 215}
 216
 217GIT_EXIT_OK=
 218trap 'die' EXIT
 219
 220# The semantics of the editor variables are that of invoking
 221# sh -c "$EDITOR \"$@\"" files ...
 222#
 223# If our trash directory contains shell metacharacters, they will be
 224# interpreted if we just set $EDITOR directly, so do a little dance with
 225# environment variables to work around this.
 226#
 227# In particular, quoting isn't enough, as the path may contain the same quote
 228# that we're using.
 229test_set_editor () {
 230        FAKE_EDITOR="$1"
 231        export FAKE_EDITOR
 232        EDITOR='"$FAKE_EDITOR"'
 233        export EDITOR
 234}
 235
 236test_decode_color () {
 237        awk '
 238                function name(n) {
 239                        if (n == 0) return "RESET";
 240                        if (n == 1) return "BOLD";
 241                        if (n == 30) return "BLACK";
 242                        if (n == 31) return "RED";
 243                        if (n == 32) return "GREEN";
 244                        if (n == 33) return "YELLOW";
 245                        if (n == 34) return "BLUE";
 246                        if (n == 35) return "MAGENTA";
 247                        if (n == 36) return "CYAN";
 248                        if (n == 37) return "WHITE";
 249                        if (n == 40) return "BLACK";
 250                        if (n == 41) return "BRED";
 251                        if (n == 42) return "BGREEN";
 252                        if (n == 43) return "BYELLOW";
 253                        if (n == 44) return "BBLUE";
 254                        if (n == 45) return "BMAGENTA";
 255                        if (n == 46) return "BCYAN";
 256                        if (n == 47) return "BWHITE";
 257                }
 258                {
 259                        while (match($0, /\033\[[0-9;]*m/) != 0) {
 260                                printf "%s<", substr($0, 1, RSTART-1);
 261                                codes = substr($0, RSTART+2, RLENGTH-3);
 262                                if (length(codes) == 0)
 263                                        printf "%s", name(0)
 264                                else {
 265                                        n = split(codes, ary, ";");
 266                                        sep = "";
 267                                        for (i = 1; i <= n; i++) {
 268                                                printf "%s%s", sep, name(ary[i]);
 269                                                sep = ";"
 270                                        }
 271                                }
 272                                printf ">";
 273                                $0 = substr($0, RSTART + RLENGTH, length($0) - RSTART - RLENGTH + 1);
 274                        }
 275                        print
 276                }
 277        '
 278}
 279
 280nul_to_q () {
 281        perl -pe 'y/\000/Q/'
 282}
 283
 284q_to_nul () {
 285        perl -pe 'y/Q/\000/'
 286}
 287
 288q_to_cr () {
 289        tr Q '\015'
 290}
 291
 292q_to_tab () {
 293        tr Q '\011'
 294}
 295
 296append_cr () {
 297        sed -e 's/$/Q/' | tr Q '\015'
 298}
 299
 300remove_cr () {
 301        tr '\015' Q | sed -e 's/Q$//'
 302}
 303
 304# In some bourne shell implementations, the "unset" builtin returns
 305# nonzero status when a variable to be unset was not set in the first
 306# place.
 307#
 308# Use sane_unset when that should not be considered an error.
 309
 310sane_unset () {
 311        unset "$@"
 312        return 0
 313}
 314
 315test_tick () {
 316        if test -z "${test_tick+set}"
 317        then
 318                test_tick=1112911993
 319        else
 320                test_tick=$(($test_tick + 60))
 321        fi
 322        GIT_COMMITTER_DATE="$test_tick -0700"
 323        GIT_AUTHOR_DATE="$test_tick -0700"
 324        export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
 325}
 326
 327# Call test_commit with the arguments "<message> [<file> [<contents>]]"
 328#
 329# This will commit a file with the given contents and the given commit
 330# message.  It will also add a tag with <message> as name.
 331#
 332# Both <file> and <contents> default to <message>.
 333
 334test_commit () {
 335        file=${2:-"$1.t"}
 336        echo "${3-$1}" > "$file" &&
 337        git add "$file" &&
 338        test_tick &&
 339        git commit -m "$1" &&
 340        git tag "$1"
 341}
 342
 343# Call test_merge with the arguments "<message> <commit>", where <commit>
 344# can be a tag pointing to the commit-to-merge.
 345
 346test_merge () {
 347        test_tick &&
 348        git merge -m "$1" "$2" &&
 349        git tag "$1"
 350}
 351
 352# This function helps systems where core.filemode=false is set.
 353# Use it instead of plain 'chmod +x' to set or unset the executable bit
 354# of a file in the working directory and add it to the index.
 355
 356test_chmod () {
 357        chmod "$@" &&
 358        git update-index --add "--chmod=$@"
 359}
 360
 361# Use test_set_prereq to tell that a particular prerequisite is available.
 362# The prerequisite can later be checked for in two ways:
 363#
 364# - Explicitly using test_have_prereq.
 365#
 366# - Implicitly by specifying the prerequisite tag in the calls to
 367#   test_expect_{success,failure,code}.
 368#
 369# The single parameter is the prerequisite tag (a simple word, in all
 370# capital letters by convention).
 371
 372test_set_prereq () {
 373        satisfied="$satisfied$1 "
 374}
 375satisfied=" "
 376
 377test_have_prereq () {
 378        # prerequisites can be concatenated with ','
 379        save_IFS=$IFS
 380        IFS=,
 381        set -- $*
 382        IFS=$save_IFS
 383
 384        total_prereq=0
 385        ok_prereq=0
 386        missing_prereq=
 387
 388        for prerequisite
 389        do
 390                total_prereq=$(($total_prereq + 1))
 391                case $satisfied in
 392                *" $prerequisite "*)
 393                        ok_prereq=$(($ok_prereq + 1))
 394                        ;;
 395                *)
 396                        # Keep a list of missing prerequisites
 397                        if test -z "$missing_prereq"
 398                        then
 399                                missing_prereq=$prerequisite
 400                        else
 401                                missing_prereq="$prerequisite,$missing_prereq"
 402                        fi
 403                esac
 404        done
 405
 406        test $total_prereq = $ok_prereq
 407}
 408
 409test_declared_prereq () {
 410        case ",$test_prereq," in
 411        *,$1,*)
 412                return 0
 413                ;;
 414        esac
 415        return 1
 416}
 417
 418# You are not expected to call test_ok_ and test_failure_ directly, use
 419# the text_expect_* functions instead.
 420
 421test_ok_ () {
 422        test_success=$(($test_success + 1))
 423        say_color "" "ok $test_count - $@"
 424}
 425
 426test_failure_ () {
 427        test_failure=$(($test_failure + 1))
 428        say_color error "not ok - $test_count $1"
 429        shift
 430        echo "$@" | sed -e 's/^/#       /'
 431        test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
 432}
 433
 434test_known_broken_ok_ () {
 435        test_fixed=$(($test_fixed+1))
 436        say_color "" "ok $test_count - $@ # TODO known breakage"
 437}
 438
 439test_known_broken_failure_ () {
 440        test_broken=$(($test_broken+1))
 441        say_color skip "not ok $test_count - $@ # TODO known breakage"
 442}
 443
 444test_debug () {
 445        test "$debug" = "" || eval "$1"
 446}
 447
 448test_run_ () {
 449        test_cleanup=:
 450        eval >&3 2>&4 "$1"
 451        eval_ret=$?
 452        eval >&3 2>&4 "$test_cleanup"
 453        if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
 454                echo ""
 455        fi
 456        return 0
 457}
 458
 459test_skip () {
 460        test_count=$(($test_count+1))
 461        to_skip=
 462        for skp in $GIT_SKIP_TESTS
 463        do
 464                case $this_test.$test_count in
 465                $skp)
 466                        to_skip=t
 467                        break
 468                esac
 469        done
 470        if test -z "$to_skip" && test -n "$test_prereq" &&
 471           ! test_have_prereq "$test_prereq"
 472        then
 473                to_skip=t
 474        fi
 475        case "$to_skip" in
 476        t)
 477                of_prereq=
 478                if test "$missing_prereq" != "$test_prereq"
 479                then
 480                        of_prereq=" of $test_prereq"
 481                fi
 482
 483                say_color skip >&3 "skipping test: $@"
 484                say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
 485                : true
 486                ;;
 487        *)
 488                false
 489                ;;
 490        esac
 491}
 492
 493test_expect_failure () {
 494        test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
 495        test "$#" = 2 ||
 496        error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
 497        export test_prereq
 498        if ! test_skip "$@"
 499        then
 500                say >&3 "checking known breakage: $2"
 501                test_run_ "$2"
 502                if [ "$?" = 0 -a "$eval_ret" = 0 ]
 503                then
 504                        test_known_broken_ok_ "$1"
 505                else
 506                        test_known_broken_failure_ "$1"
 507                fi
 508        fi
 509        echo >&3 ""
 510}
 511
 512test_expect_success () {
 513        test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
 514        test "$#" = 2 ||
 515        error "bug in the test script: not 2 or 3 parameters to test-expect-success"
 516        export test_prereq
 517        if ! test_skip "$@"
 518        then
 519                say >&3 "expecting success: $2"
 520                test_run_ "$2"
 521                if [ "$?" = 0 -a "$eval_ret" = 0 ]
 522                then
 523                        test_ok_ "$1"
 524                else
 525                        test_failure_ "$@"
 526                fi
 527        fi
 528        echo >&3 ""
 529}
 530
 531# test_external runs external test scripts that provide continuous
 532# test output about their progress, and succeeds/fails on
 533# zero/non-zero exit code.  It outputs the test output on stdout even
 534# in non-verbose mode, and announces the external script with "# run
 535# <n>: ..." before running it.  When providing relative paths, keep in
 536# mind that all scripts run in "trash directory".
 537# Usage: test_external description command arguments...
 538# Example: test_external 'Perl API' perl ../path/to/test.pl
 539test_external () {
 540        test "$#" = 4 && { test_prereq=$1; shift; } || test_prereq=
 541        test "$#" = 3 ||
 542        error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
 543        descr="$1"
 544        shift
 545        export test_prereq
 546        if ! test_skip "$descr" "$@"
 547        then
 548                # Announce the script to reduce confusion about the
 549                # test output that follows.
 550                say_color "" "# run $test_count: $descr ($*)"
 551                # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
 552                # to be able to use them in script
 553                export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
 554                # Run command; redirect its stderr to &4 as in
 555                # test_run_, but keep its stdout on our stdout even in
 556                # non-verbose mode.
 557                "$@" 2>&4
 558                if [ "$?" = 0 ]
 559                then
 560                        if test $test_external_has_tap -eq 0; then
 561                                test_ok_ "$descr"
 562                        else
 563                                say_color "" "# test_external test $descr was ok"
 564                                test_success=$(($test_success + 1))
 565                        fi
 566                else
 567                        if test $test_external_has_tap -eq 0; then
 568                                test_failure_ "$descr" "$@"
 569                        else
 570                                say_color error "# test_external test $descr failed: $@"
 571                                test_failure=$(($test_failure + 1))
 572                        fi
 573                fi
 574        fi
 575}
 576
 577# Like test_external, but in addition tests that the command generated
 578# no output on stderr.
 579test_external_without_stderr () {
 580        # The temporary file has no (and must have no) security
 581        # implications.
 582        tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
 583        stderr="$tmp/git-external-stderr.$$.tmp"
 584        test_external "$@" 4> "$stderr"
 585        [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
 586        descr="no stderr: $1"
 587        shift
 588        say >&3 "# expecting no stderr from previous command"
 589        if [ ! -s "$stderr" ]; then
 590                rm "$stderr"
 591
 592                if test $test_external_has_tap -eq 0; then
 593                        test_ok_ "$descr"
 594                else
 595                        say_color "" "# test_external_without_stderr test $descr was ok"
 596                        test_success=$(($test_success + 1))
 597                fi
 598        else
 599                if [ "$verbose" = t ]; then
 600                        output=`echo; echo "# Stderr is:"; cat "$stderr"`
 601                else
 602                        output=
 603                fi
 604                # rm first in case test_failure exits.
 605                rm "$stderr"
 606                if test $test_external_has_tap -eq 0; then
 607                        test_failure_ "$descr" "$@" "$output"
 608                else
 609                        say_color error "# test_external_without_stderr test $descr failed: $@: $output"
 610                        test_failure=$(($test_failure + 1))
 611                fi
 612        fi
 613}
 614
 615# debugging-friendly alternatives to "test [-f|-d|-e]"
 616# The commands test the existence or non-existence of $1. $2 can be
 617# given to provide a more precise diagnosis.
 618test_path_is_file () {
 619        if ! [ -f "$1" ]
 620        then
 621                echo "File $1 doesn't exist. $*"
 622                false
 623        fi
 624}
 625
 626test_path_is_dir () {
 627        if ! [ -d "$1" ]
 628        then
 629                echo "Directory $1 doesn't exist. $*"
 630                false
 631        fi
 632}
 633
 634test_path_is_missing () {
 635        if [ -e "$1" ]
 636        then
 637                echo "Path exists:"
 638                ls -ld "$1"
 639                if [ $# -ge 1 ]; then
 640                        echo "$*"
 641                fi
 642                false
 643        fi
 644}
 645
 646# test_line_count checks that a file has the number of lines it
 647# ought to. For example:
 648#
 649#       test_expect_success 'produce exactly one line of output' '
 650#               do something >output &&
 651#               test_line_count = 1 output
 652#       '
 653#
 654# is like "test $(wc -l <output) = 1" except that it passes the
 655# output through when the number of lines is wrong.
 656
 657test_line_count () {
 658        if test $# != 3
 659        then
 660                error "bug in the test script: not 3 parameters to test_line_count"
 661        elif ! test $(wc -l <"$3") "$1" "$2"
 662        then
 663                echo "test_line_count: line count for $3 !$1 $2"
 664                cat "$3"
 665                return 1
 666        fi
 667}
 668
 669# This is not among top-level (test_expect_success | test_expect_failure)
 670# but is a prefix that can be used in the test script, like:
 671#
 672#       test_expect_success 'complain and die' '
 673#           do something &&
 674#           do something else &&
 675#           test_must_fail git checkout ../outerspace
 676#       '
 677#
 678# Writing this as "! git checkout ../outerspace" is wrong, because
 679# the failure could be due to a segv.  We want a controlled failure.
 680
 681test_must_fail () {
 682        "$@"
 683        exit_code=$?
 684        if test $exit_code = 0; then
 685                echo >&2 "test_must_fail: command succeeded: $*"
 686                return 1
 687        elif test $exit_code -gt 129 -a $exit_code -le 192; then
 688                echo >&2 "test_must_fail: died by signal: $*"
 689                return 1
 690        elif test $exit_code = 127; then
 691                echo >&2 "test_must_fail: command not found: $*"
 692                return 1
 693        fi
 694        return 0
 695}
 696
 697# Similar to test_must_fail, but tolerates success, too.  This is
 698# meant to be used in contexts like:
 699#
 700#       test_expect_success 'some command works without configuration' '
 701#               test_might_fail git config --unset all.configuration &&
 702#               do something
 703#       '
 704#
 705# Writing "git config --unset all.configuration || :" would be wrong,
 706# because we want to notice if it fails due to segv.
 707
 708test_might_fail () {
 709        "$@"
 710        exit_code=$?
 711        if test $exit_code -gt 129 -a $exit_code -le 192; then
 712                echo >&2 "test_might_fail: died by signal: $*"
 713                return 1
 714        elif test $exit_code = 127; then
 715                echo >&2 "test_might_fail: command not found: $*"
 716                return 1
 717        fi
 718        return 0
 719}
 720
 721# Similar to test_must_fail and test_might_fail, but check that a
 722# given command exited with a given exit code. Meant to be used as:
 723#
 724#       test_expect_success 'Merge with d/f conflicts' '
 725#               test_expect_code 1 git merge "merge msg" B master
 726#       '
 727
 728test_expect_code () {
 729        want_code=$1
 730        shift
 731        "$@"
 732        exit_code=$?
 733        if test $exit_code = $want_code
 734        then
 735                echo >&2 "test_expect_code: command exited with $exit_code: $*"
 736                return 0
 737        else
 738                echo >&2 "test_expect_code: command exited with $exit_code, we wanted $want_code $*"
 739                return 1
 740        fi
 741}
 742
 743# test_cmp is a helper function to compare actual and expected output.
 744# You can use it like:
 745#
 746#       test_expect_success 'foo works' '
 747#               echo expected >expected &&
 748#               foo >actual &&
 749#               test_cmp expected actual
 750#       '
 751#
 752# This could be written as either "cmp" or "diff -u", but:
 753# - cmp's output is not nearly as easy to read as diff -u
 754# - not all diff versions understand "-u"
 755
 756test_cmp() {
 757        $GIT_TEST_CMP "$@"
 758}
 759
 760# This function can be used to schedule some commands to be run
 761# unconditionally at the end of the test to restore sanity:
 762#
 763#       test_expect_success 'test core.capslock' '
 764#               git config core.capslock true &&
 765#               test_when_finished "git config --unset core.capslock" &&
 766#               hello world
 767#       '
 768#
 769# That would be roughly equivalent to
 770#
 771#       test_expect_success 'test core.capslock' '
 772#               git config core.capslock true &&
 773#               hello world
 774#               git config --unset core.capslock
 775#       '
 776#
 777# except that the greeting and config --unset must both succeed for
 778# the test to pass.
 779
 780test_when_finished () {
 781        test_cleanup="{ $*
 782                } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
 783}
 784
 785# Most tests can use the created repository, but some may need to create more.
 786# Usage: test_create_repo <directory>
 787test_create_repo () {
 788        test "$#" = 1 ||
 789        error "bug in the test script: not 1 parameter to test-create-repo"
 790        repo="$1"
 791        mkdir -p "$repo"
 792        (
 793                cd "$repo" || error "Cannot setup test environment"
 794                "$GIT_EXEC_PATH/git-init" "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
 795                error "cannot run git init -- have you built things yet?"
 796                mv .git/hooks .git/hooks-disabled
 797        ) || exit
 798}
 799
 800test_done () {
 801        GIT_EXIT_OK=t
 802
 803        if test -z "$HARNESS_ACTIVE"; then
 804                test_results_dir="$TEST_DIRECTORY/test-results"
 805                mkdir -p "$test_results_dir"
 806                test_results_path="$test_results_dir/${0%.sh}-$$.counts"
 807
 808                echo "total $test_count" >> $test_results_path
 809                echo "success $test_success" >> $test_results_path
 810                echo "fixed $test_fixed" >> $test_results_path
 811                echo "broken $test_broken" >> $test_results_path
 812                echo "failed $test_failure" >> $test_results_path
 813                echo "" >> $test_results_path
 814        fi
 815
 816        if test "$test_fixed" != 0
 817        then
 818                say_color pass "# fixed $test_fixed known breakage(s)"
 819        fi
 820        if test "$test_broken" != 0
 821        then
 822                say_color error "# still have $test_broken known breakage(s)"
 823                msg="remaining $(($test_count-$test_broken)) test(s)"
 824        else
 825                msg="$test_count test(s)"
 826        fi
 827        case "$test_failure" in
 828        0)
 829                # Maybe print SKIP message
 830                [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
 831
 832                if test $test_external_has_tap -eq 0; then
 833                        say_color pass "# passed all $msg"
 834                        say "1..$test_count$skip_all"
 835                fi
 836
 837                test -d "$remove_trash" &&
 838                cd "$(dirname "$remove_trash")" &&
 839                rm -rf "$(basename "$remove_trash")"
 840
 841                exit 0 ;;
 842
 843        *)
 844                if test $test_external_has_tap -eq 0; then
 845                        say_color error "# failed $test_failure among $msg"
 846                        say "1..$test_count"
 847                fi
 848
 849                exit 1 ;;
 850
 851        esac
 852}
 853
 854# Test the binaries we have just built.  The tests are kept in
 855# t/ subdirectory and are run in 'trash directory' subdirectory.
 856if test -z "$TEST_DIRECTORY"
 857then
 858        # We allow tests to override this, in case they want to run tests
 859        # outside of t/, e.g. for running tests on the test library
 860        # itself.
 861        TEST_DIRECTORY=$(pwd)
 862fi
 863GIT_BUILD_DIR="$TEST_DIRECTORY"/..
 864
 865if test -n "$valgrind"
 866then
 867        make_symlink () {
 868                test -h "$2" &&
 869                test "$1" = "$(readlink "$2")" || {
 870                        # be super paranoid
 871                        if mkdir "$2".lock
 872                        then
 873                                rm -f "$2" &&
 874                                ln -s "$1" "$2" &&
 875                                rm -r "$2".lock
 876                        else
 877                                while test -d "$2".lock
 878                                do
 879                                        say "Waiting for lock on $2."
 880                                        sleep 1
 881                                done
 882                        fi
 883                }
 884        }
 885
 886        make_valgrind_symlink () {
 887                # handle only executables
 888                test -x "$1" || return
 889
 890                base=$(basename "$1")
 891                symlink_target=$GIT_BUILD_DIR/$base
 892                # do not override scripts
 893                if test -x "$symlink_target" &&
 894                    test ! -d "$symlink_target" &&
 895                    test "#!" != "$(head -c 2 < "$symlink_target")"
 896                then
 897                        symlink_target=../valgrind.sh
 898                fi
 899                case "$base" in
 900                *.sh|*.perl)
 901                        symlink_target=../unprocessed-script
 902                esac
 903                # create the link, or replace it if it is out of date
 904                make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
 905        }
 906
 907        # override all git executables in TEST_DIRECTORY/..
 908        GIT_VALGRIND=$TEST_DIRECTORY/valgrind
 909        mkdir -p "$GIT_VALGRIND"/bin
 910        for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
 911        do
 912                make_valgrind_symlink $file
 913        done
 914        OLDIFS=$IFS
 915        IFS=:
 916        for path in $PATH
 917        do
 918                ls "$path"/git-* 2> /dev/null |
 919                while read file
 920                do
 921                        make_valgrind_symlink "$file"
 922                done
 923        done
 924        IFS=$OLDIFS
 925        PATH=$GIT_VALGRIND/bin:$PATH
 926        GIT_EXEC_PATH=$GIT_VALGRIND/bin
 927        export GIT_VALGRIND
 928elif test -n "$GIT_TEST_INSTALLED" ; then
 929        GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
 930        error "Cannot run git from $GIT_TEST_INSTALLED."
 931        PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
 932        GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
 933else # normal case, use ../bin-wrappers only unless $with_dashes:
 934        git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
 935        if ! test -x "$git_bin_dir/git" ; then
 936                if test -z "$with_dashes" ; then
 937                        say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
 938                fi
 939                with_dashes=t
 940        fi
 941        PATH="$git_bin_dir:$PATH"
 942        GIT_EXEC_PATH=$GIT_BUILD_DIR
 943        if test -n "$with_dashes" ; then
 944                PATH="$GIT_BUILD_DIR:$PATH"
 945        fi
 946fi
 947GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
 948unset GIT_CONFIG
 949GIT_CONFIG_NOSYSTEM=1
 950GIT_CONFIG_NOGLOBAL=1
 951export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL
 952
 953. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
 954
 955if test -z "$GIT_TEST_CMP"
 956then
 957        if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
 958        then
 959                GIT_TEST_CMP="$DIFF -c"
 960        else
 961                GIT_TEST_CMP="$DIFF -u"
 962        fi
 963fi
 964
 965GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
 966export GITPERLLIB
 967test -d "$GIT_BUILD_DIR"/templates/blt || {
 968        error "You haven't built things yet, have you?"
 969}
 970
 971if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
 972then
 973        GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
 974        export GITPYTHONLIB
 975        test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
 976                error "You haven't built git_remote_helpers yet, have you?"
 977        }
 978fi
 979
 980if ! test -x "$GIT_BUILD_DIR"/test-chmtime; then
 981        echo >&2 'You need to build test-chmtime:'
 982        echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
 983        exit 1
 984fi
 985
 986# Test repository
 987test="trash directory.$(basename "$0" .sh)"
 988test -n "$root" && test="$root/$test"
 989case "$test" in
 990/*) TRASH_DIRECTORY="$test" ;;
 991 *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
 992esac
 993test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
 994rm -fr "$test" || {
 995        GIT_EXIT_OK=t
 996        echo >&5 "FATAL: Cannot prepare test area"
 997        exit 1
 998}
 999
1000test_create_repo "$test"
1001# Use -P to resolve symlinks in our working directory so that the cwd
1002# in subprocesses like git equals our $PWD (for pathname comparisons).
1003cd -P "$test" || exit 1
1004
1005HOME=$(pwd)
1006export HOME
1007
1008this_test=${0##*/}
1009this_test=${this_test%%-*}
1010for skp in $GIT_SKIP_TESTS
1011do
1012        case "$this_test" in
1013        $skp)
1014                say_color skip >&3 "skipping test $this_test altogether"
1015                skip_all="skip all tests in $this_test"
1016                test_done
1017        esac
1018done
1019
1020# Provide an implementation of the 'yes' utility
1021yes () {
1022        if test $# = 0
1023        then
1024                y=y
1025        else
1026                y="$*"
1027        fi
1028
1029        while echo "$y"
1030        do
1031                :
1032        done
1033}
1034
1035# Fix some commands on Windows
1036case $(uname -s) in
1037*MINGW*)
1038        # Windows has its own (incompatible) sort and find
1039        sort () {
1040                /usr/bin/sort "$@"
1041        }
1042        find () {
1043                /usr/bin/find "$@"
1044        }
1045        sum () {
1046                md5sum "$@"
1047        }
1048        # git sees Windows-style pwd
1049        pwd () {
1050                builtin pwd -W
1051        }
1052        # no POSIX permissions
1053        # backslashes in pathspec are converted to '/'
1054        # exec does not inherit the PID
1055        test_set_prereq MINGW
1056        test_set_prereq SED_STRIPS_CR
1057        ;;
1058*CYGWIN*)
1059        test_set_prereq POSIXPERM
1060        test_set_prereq EXECKEEPSPID
1061        test_set_prereq NOT_MINGW
1062        test_set_prereq SED_STRIPS_CR
1063        ;;
1064*)
1065        test_set_prereq POSIXPERM
1066        test_set_prereq BSLASHPSPEC
1067        test_set_prereq EXECKEEPSPID
1068        test_set_prereq NOT_MINGW
1069        ;;
1070esac
1071
1072test -z "$NO_PERL" && test_set_prereq PERL
1073test -z "$NO_PYTHON" && test_set_prereq PYTHON
1074
1075# test whether the filesystem supports symbolic links
1076ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1077rm -f y
1078
1079# When the tests are run as root, permission tests will report that
1080# things are writable when they shouldn't be.
1081test -w / || test_set_prereq SANITY